
const int JOYSTICK_X_AXIS = A3;
const int JOYSTICK_Y_AXIS = A4;
const int JOYSTICK_BUTTON = 2;

const int GREEN_BUTTON = 3; // shift 
const int RED_BUTTON = 4; 
const int WHITE_BUTTON = 6; 
const int YELLOW_BUTTON = 7;



uint8_t buf[8] = { 
  0 
};  


int old_x = 0;
int old_y = 0;
int old_joystick_button = LOW;

int old_green = LOW;
int old_red = LOW;
int old_white = LOW;
int old_yellow = LOW;

byte MOD_SHIFT = 0x02;
byte SC_RIGHT_ARROW = 0x4f;
byte SC_LEFT_ARROW = 0x50;
byte SC_DOWN_ARROW = 0x51;
byte SC_UP_ARROW = 0x52;
byte SC_A = 0x04;  



void releaseKey() {
  buf[0] = 0;
  buf[2] = 0;
  buf[3] = 0;
  Serial.write(buf, 8);  // Release key  
}

 
void setup() {
  pinMode(JOYSTICK_BUTTON, INPUT_PULLUP);
  pinMode(GREEN_BUTTON, INPUT_PULLUP);
  pinMode(RED_BUTTON, INPUT_PULLUP);
  pinMode(WHITE_BUTTON, INPUT_PULLUP);
  pinMode(YELLOW_BUTTON, INPUT_PULLUP);
  
  Serial.begin(9600);
  delay(2000);
}

void loop() {
  boolean hasChange = false;

  int green = digitalRead(GREEN_BUTTON);
  if (old_green != green) {
    hasChange = true;
    old_green = green;
    
  }
  int red = digitalRead(RED_BUTTON);
  if (old_red != red) {
    hasChange = true;
    old_red = red;
    
  }
  
  int x = analogRead(JOYSTICK_X_AXIS) / 344;
  
  if (x != old_x) {
    hasChange = true;
    old_x = x;
  }
  
  int y = analogRead(JOYSTICK_Y_AXIS) / 344;
  if (y != old_y) {
    hasChange = true;
    old_y = y;
  }

  
  if (hasChange) {
    int index = 2;
    
    buf[0] = !green ? MOD_SHIFT : 0;
    if (!red) {
      buf[index] = SC_A;
      index++;
    }
    
    if (x == 0) {
      buf[index] = SC_LEFT_ARROW;
      index ++;
    } else if (x == 2) {
      buf[index] = SC_RIGHT_ARROW;
      index ++;
    }
    
    if (y == 0) {
      buf[index] = SC_UP_ARROW;
      index++;
    } else if (y == 2) {
      buf[index] = SC_DOWN_ARROW;
      index++;
    }
    
    for (int i=index; i < 8; i++) {
      buf[index] = 0;
    }

    Serial.write(buf, 8);  
  }

  delay(25); 
}
